﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PV178.Tutorial3.SpringfieldUniversityFull
{
    class Program
    {
        static void Main(string[] args)
        {

            University springfieldUniversity = new University();

            springfieldUniversity.LoadSeminars("seminars.txt");
            springfieldUniversity.LoadFromFile("data.txt");

            //LoadFromCode(springfieldUniversity);



            foreach (var student in springfieldUniversity.GetWorstStudents())
            {
                Console.WriteLine("Worst student: {0}", student);
            }

            Console.WriteLine("Best students: " + string.Join("; ", springfieldUniversity.GetBestStudents().Select(x => x.LastName + " / " + x.Uco)));


            Console.WriteLine();

            //springfieldUniversity.SaveToFile("data.txt");
            //springfieldUniversity.SaveSeminars("seminars.txt");

            springfieldUniversity.GetStatistics2();
        }

        private static void LoadFromCode(University springfieldUniversity)
        {
            /*
             * Create students and seminars programatically
             */

            Student[] students =  {
                new Student() {FirstName = "Homer",     LastName = "Simpson",  Uco = 1},
                new Student() {FirstName = "Marge",     LastName = "Simpson",  Uco = 2},
                new Student() {FirstName = "Bart",      LastName = "Simpson",  Uco = 3},
                new Student() {FirstName = "Lisa",      LastName = "Simpson",  Uco = 4},
                new Student() {FirstName = "Mongomery", LastName = "Burns",    Uco = 5},
                new Student() {FirstName = "Kent",      LastName = "Brockman", Uco = 6},
                new Student() {FirstName = "Moe",       LastName = "Szyslak",  Uco = 7},
                new Student() {FirstName = "Krusty",    LastName = "Clown",    Uco = 8},
                new Student() {FirstName = "Ned",       LastName = "Flanders", Uco = 9}
            };

            Seminar[] seminars = {
                new Seminar("PV178", "C# Introduction"),
                new Seminar("PB069", "Desktop Apps in C#"),
                new Seminar("PB162", "Introduction to Java"),
                new Seminar("PA165", "Java EE")
            };

            students[0].Marks.Add(seminars[0], Mark.F);
            students[0].Marks.Add(seminars[1], Mark.E);
            students[1].Marks.Add(seminars[1], Mark.C);
            students[1].Marks.Add(seminars[2], Mark.E);
            students[2].Marks.Add(seminars[1], Mark.A);
            students[2].Marks.Add(seminars[2], Mark.A);
            students[2].Marks.Add(seminars[0], Mark.D);
            students[3].Marks.Add(seminars[1], Mark.E);
            students[4].Marks.Add(seminars[0], Mark.B);
            students[4].Marks.Add(seminars[2], Mark.F);
            students[5].Marks.Add(seminars[1], Mark.A);
            students[6].Marks.Add(seminars[0], Mark.A);
            students[6].Marks.Add(seminars[1], Mark.A);
            students[6].Marks.Add(seminars[2], Mark.A);
            students[6].Marks.Add(seminars[3], Mark.A);
            students[7].Marks.Add(seminars[0], Mark.C);
            students[7].Marks.Add(seminars[1], Mark.D);
            students[7].Marks.Add(seminars[2], Mark.C);
            students[8].Marks.Add(seminars[0], Mark.F);
            students[8].Marks.Add(seminars[1], Mark.B);

            foreach (var student in students)
            {
                springfieldUniversity.Students.Add(student);
            }

            foreach (var seminar in seminars)
            {
                springfieldUniversity.Seminars.Add(seminar);
            }
        }
    }
}
