﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace PV178.Tutorial3.SpringfieldUniversityFull
{
    public class Student
    {
        private const string EmailValidationRegex = @"^(([a-zA-Z0-9_\-\.]+)@([a-zA-Z0-9_\-\.]+)\.([a-zA-Z]{2,5}){1,25})+([;.](([a-zA-Z0-9_\-\.]+)@([a-zA-Z0-9_\-\.]+)\.([a-zA-Z]{2,5}){1,25})+)*$";


        private readonly IDictionary<Seminar, Mark?> marks = new Dictionary<Seminar, Mark?>();

        private string personalEmail;


        public IDictionary<Seminar, Mark?> Marks { get { return marks; } }

        public int Uco { get; set; }

        public string FirstName { get; set; }

        public string LastName { get; set; }

        public string Email
        {
            get { return personalEmail; }
            set
            {
                if (value == null)
                {
                    personalEmail = null;
                }
                else
                {
                    Match emailMatch = Regex.Match(value, EmailValidationRegex, RegexOptions.Singleline | RegexOptions.IgnoreCase);

                    if (!emailMatch.Success)
                        throw new ArgumentException("Argument must be valid email address.");

                    personalEmail = value;
                }
            }
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(this, obj))
                return true;

            if (obj == null || GetType() != obj.GetType())
            {
                return false;
            }

            Student other = (Student)obj;

            return Uco == other.Uco;
        }

        public override int GetHashCode()
        {
            return Uco;
        }

        public override string ToString()
        {
            return string.Format("{1}, {2} (UCO: {0})", Uco, LastName, FirstName);
        }
    }
}
