﻿using System;
using System.Linq;

namespace PV178.Tutorial3.SpringfieldUniversitySimple
{
    class Program
    {
        private const string PB069 = "PB069";
        private const string PV178 = "PV178";
        private const string PB162 = "PB162";
        private const string PA165 = "PA165";

        static void Main(string[] args)
        {

            University springfieldUniversity = new University();

            springfieldUniversity.LoadFromFile("simple-students.txt");

            //LoadFromCode(springfieldUniversity);



            foreach (var student in springfieldUniversity.GetWorstStudents())
            {
                Console.WriteLine("Worst student: {0}", student);
            }

            Console.WriteLine("Best students: " + string.Join("; ", springfieldUniversity.GetBestStudents().Select(x => x.LastName + " / " + x.Uco)));


            Console.WriteLine();

            //springfieldUniversity.SaveToFile("simple-students.txt");

            springfieldUniversity.PrintMarksGroupedBySeminars();
        }

        private static void LoadFromCode(University springfieldUniversity)
        {
            /*
             * Create students and seminars programatically
             */

            Student[] students =  {
                new Student() {FirstName = "Homer",     LastName = "Simpson",  Uco = 1},
                new Student() {FirstName = "Marge",     LastName = "Simpson",  Uco = 2},
                new Student() {FirstName = "Bart",      LastName = "Simpson",  Uco = 3},
                new Student() {FirstName = "Lisa",      LastName = "Simpson",  Uco = 4},
                new Student() {FirstName = "Mongomery", LastName = "Burns",    Uco = 5},
                new Student() {FirstName = "Kent",      LastName = "Brockman", Uco = 6},
                new Student() {FirstName = "Moe",       LastName = "Szyslak",  Uco = 7},
                new Student() {FirstName = "Krusty",    LastName = "Clown",    Uco = 8},
                new Student() {FirstName = "Ned",       LastName = "Flanders", Uco = 9}
            };

            students[0].Marks.Add(PV178, Mark.F);
            students[0].Marks.Add(PB069, Mark.E);
            students[1].Marks.Add(PB069, Mark.C);
            students[1].Marks.Add(PB162, Mark.E);
            students[2].Marks.Add(PB069, Mark.A);
            students[2].Marks.Add(PB162, Mark.A);
            students[2].Marks.Add(PV178, Mark.D);
            students[3].Marks.Add(PB069, Mark.E);
            students[4].Marks.Add(PV178, Mark.B);
            students[4].Marks.Add(PB162, Mark.F);
            students[5].Marks.Add(PB069, Mark.A);
            students[6].Marks.Add(PV178, Mark.A);
            students[6].Marks.Add(PB069, Mark.A);
            students[6].Marks.Add(PB162, Mark.A);
            students[6].Marks.Add(PA165, Mark.A);
            students[7].Marks.Add(PV178, Mark.C);
            students[7].Marks.Add(PB069, null);
            students[7].Marks.Add(PB162, Mark.C);
            students[8].Marks.Add(PV178, Mark.F);
            students[8].Marks.Add(PB069, Mark.B);


            foreach (var student in students)
            {
                springfieldUniversity.Students.Add(student);
            }
        }
    }
}
